#define _XOPEN_SOURCE 600


#include <stdlib.h>
#include <malloc.h>
#include <stdio.h>

#include "xvmul.h"
#include "xsmul.h"
#include "xfill.h"
#include "xsvtvp.h"
#include "xvvvmul.h"
#include "xzero.h"


double *dvector_align(int size, int alignment);

unsigned long long getticks(void);

int main(){


   int i,N;
   N = 7;
   N = 1000;
   fprintf(stderr,"N = %d\n",N);

   double *x, *y, *z;
   double f0, f1, s1f;
   unsigned long long t1, t2, t3, to1, to2, to3a, to3c, to3f;


   /* allignment test */
   {
    double *xx,*yy,*zz;
    xx = dvector_align(20,16);
    int nn = 3;
     
    yy = xx+nn + nn%2;
    zz = yy+nn + nn%2;
    fprintf(stderr,"N = 20: xx\%16 = %d,  yy\%16 = %d, zz\%16 = %d\n", (int)xx % 16, (int)yy % 16, (int)zz % 16);
    free(xx);

    xx = dvector_align(19,16);
    yy = &xx[3];
    zz = &xx[6];
    fprintf(stderr,"N=19: xx\%16 = %d,  yy\%16 = %d, zz\%16 = %d\n", (int)xx % 16, (int)yy % 16, (int)zz % 16);
    free(xx);

   }


  /*   */


   x = dvector_align(N*3,16);
   y = x+N;
   z = x+2*N;

   for (int i=0; i < N; i++)
      x[i] = y[i] = ((double) i)/10.0;


   /* test dvmul operator */

   to1 = getticks();
   dvmul(N,x,y,z);
   to2 = getticks();
   to3a = to2-to1 ;
/*
   fprintf(stdout,"\n");
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/
   s1f = (double)(to3a);

   fprintf( stderr, "dvmul: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);



   to1 = getticks();
   dvmul_disjoint(N,x,y,z);
   to2 = getticks(); 
   to3a = to2-to1 ;
/*
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/

   s1f = (double)(to3a);

   fprintf( stderr, "dvmul_disjoint: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);  


   to1 = getticks();
   dvmul_disjoint_double_hummer(N,x,y,z);
   to2 = getticks();
   to3a = to2-to1 ;

/*
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/   
   s1f = (double)(to3a);

   fprintf( stderr, "dvmul_disjoint_double_hummer:  N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   /* end testing dvmul operator */

   /* test dsmul operator */

   to1 = getticks();
   dsmul(N,2.0,x,z);
   to2 = getticks();
   to3a = to2-to1 ;
/*
   fprintf(stdout,"\n");
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/
   s1f = (double)(to3a);
   fprintf( stderr, "dsmul: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

 
   to1 = getticks();
   dsmul_disjoint(N,2.0,x,z);
   to2 = getticks();
   to3a = to2-to1 ;

/*
   fprintf(stdout,"\n");
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/

   s1f = (double)(to3a);
   fprintf( stderr, "dsmul_disjoint: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   to1 = getticks();
   dsmul_disjoint_double_hummer(N,2.0,x,z);
   to2 = getticks();
   to3a = to2-to1 ;

/*
   fprintf(stdout,"\n");
   for (i=0; i < N; i++)
      fprintf(stdout,"z[%d] = %f\n",i,z[i]);
   fprintf(stdout,"\n");
*/

   s1f = (double)(to3a);
   fprintf( stderr, "dsmul_disjoint_double_hummer: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   /* end of testing dsmul */

   /* start testing dfill */

   to1 = getticks();
   dfill_simple(N,x,2.0);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dfill_simple: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   to1 = getticks();
   dfill_double_hummer(N,x,2.0);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dfill_double_hummer: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   /* end of testing dfill */

   /* start testing  dsvtvp */
      
   to1 = getticks();
   dsvtvp (N, 3.0, x, y, z);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dsvtvp: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   to1 = getticks();
   dsvtvp_disjoint (N, 3.0, x, y, z);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dsvtvp_disjoint: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);


   /* end of testing dsvtvp */

   /* start testing dvvvmul */
   double res1, res2, res3;

   to1 = getticks();
   res1 = dvvvmul(N,x,y,z);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvvvmul: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   to1 = getticks();
   res2 = dvvvmul_xyz_inc1(N,x,y,z);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvvvmul_xyz_inc1: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);
   
   to1 = getticks();
   res3 = dvvvmul_xyz_intrinsics(N,x,y,z);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvvvmul_xyz_intrinsics: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   fprintf( stderr, "dvvvmul:  res1 = %2.10f, res2 = %2.10f, res3 = %2.10f \n",res1, res2, res3);

   /* end testing dvvvmul */

   /* start testing dvv2mul */

   to1 = getticks();
   res1 = dvv2mul(N,x,y);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvv2mul: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   to1 = getticks();
   res2 = dvvvmul_xyy_inc1(N,x,y);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvvvmul_xyy_inc1: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   to1 = getticks();
   res3 = dvvvmul_xyy_intrinsics(N,x,y);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dvvvmul_xyy_intrinsics: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   fprintf( stderr, "dvvvmul:  res1 = %2.10f, res2 = %2.10f, res3 = %2.10f \n",res1, res2, res3);

   /* end testing dvvvmul */


  /* start testing dzero */
   fprintf( stderr, "\n");

   to1 = getticks();
   dzero(N,x);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dzero: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);

   to1 = getticks();
   dzero_align(N,x);
   to2 = getticks();
   to3a = to2-to1 ;

   s1f = (double)(to3a);
   fprintf( stderr, "dzero_align: N = %d, Intr time = %18.12f, MFlops = %18.12lf  \n",N, s1f, N / (s1f/850e6)/1e6);



   free(x);
 


  return 0;
}

