#include  "xvmul.h"


void   dvmul (int N, double *x, double *y, double *z){
#if 0
   for (int i = 0; i < N; i++)
      *z++   = (*x++) * (*y++);
#endif 
  for (int i = 0; i < N; i++)
    z[i] = x[i]*y[i];
}

void   dvmul_disjoint(int N, double *x, double *y, double *z){
#pragma disjoint(*x, *y)
#pragma disjoint(*x, *z)
#pragma disjoint(*z, *y)
  for (int i = 0; i < N; i++)
    z[i] = x[i]*y[i];
}

void  dvmul_disjoint_double_hummer(int N, double *x, double *y, double *z){

  int i, j;
  double _Complex x1, y1, x2, y2, x3, y3, x4, y4, x5, y5, x6, y6, x7, y7, x8, y8;

  for (i=0; i < (N-(N%16)); i += 16){

        x1 = __lfpd( &x[i] );
        x2 = __lfpd( &x[i+2] );
        x3 = __lfpd( &x[i+4] );
        x4 = __lfpd( &x[i+6] );
        x5 = __lfpd( &x[i+8] );
        x6 = __lfpd( &x[i+10] );
        x7 = __lfpd( &x[i+12] );
        x8 = __lfpd( &x[i+14] );

        y1 = __lfpd( &y[i] );
        y2 = __lfpd( &y[i+2] );
        y3 = __lfpd( &y[i+4] );
        y4 = __lfpd( &y[i+6] );
        y5 = __lfpd( &y[i+8] );
        y6 = __lfpd( &y[i+10] );
        y7 = __lfpd( &y[i+12] );
        y8 = __lfpd( &y[i+14] );

        y1 = __fpmul(x1,y1);
        y2 = __fpmul(x2,y2);
        y3 = __fpmul(x3,y3);
        y4 = __fpmul(x4,y4);
        y5 = __fpmul(x5,y5);
        y6 = __fpmul(x6,y6);
        y7 = __fpmul(x7,y7);
        y8 = __fpmul(x8,y8);

        __stfpd( &z[i], y1 );
        __stfpd( &z[i+2], y2 );
        __stfpd( &z[i+4], y3 );
        __stfpd( &z[i+6], y4 );
        __stfpd( &z[i+8], y5 );
        __stfpd( &z[i+10], y6 );
        __stfpd( &z[i+12], y7 );
        __stfpd( &z[i+14], y8 );
    }

    for (j = i; j < N; j++)
      z[j] = x[j]*y[j];
}


